#include <stdbool.h>
#include "processor.h"
#include "fdserial.h"
#include "gcode_struct.h"
#include "config.h"
#include "StructTest.h"

/// cog variables
static int serial_processor_cog = 0;
static int serial_processor_stack[100];

volatile bool gcode_struct_received;

void serial_processor(void *par);

// start the serial processor
void serial_processor_init()
{
	if(serial_processor_cog == 0)
	{
		serial_processor_cog = 1 + cogstart(&serial_processor, NULL,
			serial_processor_stack, sizeof serial_processor_stack);
	}
}

// stop the serial processor
void serial_processor_stop()
{
	if(serial_processor_cog > 0)
	{
		cogstop(serial_processor_cog - 1);
		serial_processor_cog = 0;
	}
}

void serial_processor(void *par)
{
	fdserial *processor;

	processor = fdserial_open(PROCESSOR_TX, PROCESSOR_TX, PROCESSOR_MODE, PROCESSOR_BAUD);

	do
	{
		if(fdserial_rxReady(processor) != 0)
		{
			volatile GCODE_STRUCT received_gcode;
			char received_struct_array[sizeof(received_gcode)];

			for(uint32_t i = 0; i < sizeof(received_gcode); i++)
			{
				received_struct_array[i] = fdserial_rxChar(processor);
			}

			memcpy(&received_gcode, &received_struct_array, sizeof(received_gcode));
			memcpy(&sent_gcode, &received_gcode, sizeof(sent_gcode));

			gcode_struct_received = true;
		}		
	}
	while(serial_processor_cog > 0);
}


/*
void serial_processor(void *par)
{
	fdserial *processor;

	volatile GCODE_STRUCT received_gcode;

	char received_struct_array[sizeof(received_gcode)];

	processor = fdserial_open(PROCESSOR_TX, PROCESSOR_TX, PROCESSOR_MODE, PROCESSOR_BAUD);

	do
	{
		if(fdserial_rxReady(processor) != 0)
		{

			for(uint32_t i = 0; i < sizeof(received_gcode); i++)
			{
				received_struct_array[i] = fdserial_rxChar(processor);
			}

			memcpy(&received_gcode, &received_struct_array, sizeof(received_gcode));
			memcpy(&sent_gcode, &received_gcode, sizeof(sent_gcode));

			memset(received_gcode.gcode_fileline, 0, strlen(received_gcode.gcode_fileline));
			memset(received_gcode.valid, 0, strlen(received_gcode.valid));
			memset(received_gcode.g_char, 0, strlen(received_gcode.g_char));
			memset(received_gcode.m_char, 0, strlen(received_gcode.m_char));
			memset(received_gcode.t_char, 0, strlen(received_gcode.t_char));
			memset(received_gcode.s_char, 0, strlen(received_gcode.s_char));
			memset(received_gcode.p_char, 0, strlen(received_gcode.p_char));
			memset(received_gcode.x_char, 0, strlen(received_gcode.x_char));
			memset(received_gcode.y_char, 0, strlen(received_gcode.y_char));
			memset(received_gcode.z_char, 0, strlen(received_gcode.z_char));
			memset(received_gcode.e_char, 0, strlen(received_gcode.e_char));
			memset(received_gcode.f_char, 0, strlen(received_gcode.f_char));

			received_gcode.g_num = 0;
			received_gcode.m_num = 0;
			received_gcode.t_num = 0;
			received_gcode.s_num = 0;
			received_gcode.p_num = 0;
			received_gcode.x_num = 0;
			received_gcode.y_num = 0;
			received_gcode.z_num = 0;
			received_gcode.e_num = 0;
			received_gcode.f_num = 0;

			received_gcode.x_travel = 0;
			received_gcode.y_travel = 0;
			received_gcode.z_travel = 0;
			received_gcode.e_travel = 0;

			received_gcode.x_dir = 0; 
			received_gcode.x_start_stop_speed = 0;
			received_gcode.x_total_steps = 0;
			received_gcode.x_ramp_up_steps = 0;
			received_gcode.x_running_steps = 0;
			received_gcode.x_ramp_down_steps = 0;
			received_gcode.x_ramp_inc_dec = 0;

			received_gcode.y_dir = 0;
			received_gcode.y_start_stop_speed = 0;
			received_gcode.y_total_steps = 0;
			received_gcode.y_ramp_up_steps = 0;
			received_gcode.y_running_steps = 0;
			received_gcode.y_ramp_down_steps = 0;
			received_gcode.y_ramp_inc_dec = 0;

			received_gcode.z_dir = 0;
			received_gcode.z_start_stop_speed = 0;
			received_gcode.z_total_steps = 0;
			received_gcode.z_ramp_up_steps = 0;
			received_gcode.z_running_steps = 0;
			received_gcode.z_ramp_down_steps = 0;
			received_gcode.z_ramp_inc_dec = 0;

			received_gcode.e_dir = 0;
			received_gcode.e_start_stop_speed = 0;
			received_gcode.e_total_steps = 0;
			received_gcode.e_ramp_up_steps = 0;
			received_gcode.e_running_steps = 0;
			received_gcode.e_ramp_down_steps = 0;
			received_gcode.e_ramp_inc_dec = 0;

			gcode_struct_received = true;
		}		
	}
	while(serial_processor_cog > 0);
}
*/